import inspect
from typing import Optional

from discord.ext import commands

from bot_core.abc.client_utils_abc import ClientUtilsABC
from bot_core.exception.check_error import CheckError


class EventChecks:
    _client_utils: Optional[ClientUtilsABC] = None

    @classmethod
    def init(
        cls,
        client_utils: ClientUtilsABC,
    ):
        cls._client_utils = client_utils

    @classmethod
    def check_is_ready(cls, func):
        async def check_if_bot_is_ready(*args, **kwargs):
            result = await cls._client_utils.check_if_bot_is_ready_yet()
            if not result:

                def empty(*args, **kwargs):
                    return

                return empty
            return await func(*args, **kwargs)

        check_if_bot_is_ready.__name__ = func.__name__
        sig = inspect.signature(func)
        check_if_bot_is_ready.__signature__ = sig.replace(parameters=tuple(sig.parameters.values())[1:])
        return check_if_bot_is_ready
