from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class MaintenanceModeMigration(MigrationABC):
    name = "1.2.0_MaintenanceModeMigration"

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, "Running upgrade")

        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_Technician
                    ADD Maintenance BOOLEAN DEFAULT FALSE AFTER MaxSteamOfferCount;
                """
            )
        )

        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_TechnicianHistory
                    ADD Maintenance BOOLEAN DEFAULT FALSE AFTER MaxSteamOfferCount;
                """
            )
        )
        self._exec(__file__, "config/technician.sql")

    def downgrade(self):
        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_Technician DROP COLUMN Maintenance;
                """
            )
        )
        self._cursor.execute(
            str(
                f"""
                    ALTER TABLE CFG_TechnicianHistory DROP COLUMN Maintenance;
                """
            )
        )
